﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
//using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using DocumentFormat.OpenXml;
using DocumentFormat.OpenXml.Packaging;
using DocumentFormat.OpenXml.Spreadsheet;
using Xdr = DocumentFormat.OpenXml.Drawing.Spreadsheet;
using Ap = DocumentFormat.OpenXml.ExtendedProperties;
using Vt = DocumentFormat.OpenXml.VariantTypes;
using A = DocumentFormat.OpenXml.Drawing;
using System.IO.Packaging;
using System.IO;
using System.Xml;
using System.Text.RegularExpressions;

namespace ExportGridSample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = MakeDataTable();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                string excelFilePath = Application.StartupPath + "\\test.xlsx";
             
                //Make a Excel file.
                using (OpenXml ooXml = new OpenXml())
                {
                    ooXml.CreateSpreadsheetWorkbook(excelFilePath);
                }

                #region For handling System.ArgumentOutOfRangeException
                /*
                string relFile = "/xl/_rels/workbook.xml.rels";
                Package xlPackage = null;

                try
                {
                    xlPackage = Package.Open(excelFilePath, FileMode.Open, FileAccess.ReadWrite);
                    Uri xmlUri = new Uri(relFile, UriKind.Relative);
                    PackagePart xmlPart = xlPackage.GetPart(xmlUri);

                    XmlNodeList nodeList;
                    XmlDocument doc = new XmlDocument();
                    doc.Load(xmlPart.GetStream());

                    nodeList = doc.DocumentElement.ChildNodes;

                    foreach (XmlNode node in doc.DocumentElement.ChildNodes)
                    {
                        node.Attributes["Target"].Value = Regex.Replace(node.Attributes["Target"].Value, @"^/xl/", "");
                    }

                    doc.Save(xmlPart.GetStream(FileMode.Create, FileAccess.Write));
                }
                catch (Exception ex)
                {
                    throw ex;
                }
                finally
                {
                    if (xlPackage != null)
                    {
                        xlPackage.Flush();
                        xlPackage.Close();
                    }
                }
                */
                #endregion

                Infragistics.Excel.Workbook wb = Infragistics.Excel.Workbook.Load(excelFilePath);
                ultraGridExcelExporter1.Export(ultraGrid1, wb.Worksheets[0], 0, 0);
                Infragistics.Excel.BIFF8Writer.WriteWorkbookToFile(wb, excelFilePath);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        // Create new DataTable.
        private DataTable MakeDataTable()
        {            
            DataTable table = new DataTable();

            // Declare DataColumn and DataRow variables.
            DataColumn column;
            DataRow row;

            // Create new DataColumn, set DataType, ColumnName
            // and add to DataTable.    
            column = new DataColumn();
            column.DataType = System.Type.GetType("System.Int32");
            column.ColumnName = "id";
            table.Columns.Add(column);

            // Create second column.
            column = new DataColumn();
            column.DataType = Type.GetType("System.String");
            column.ColumnName = "item1";
            table.Columns.Add(column);

            // Create second column.
            column = new DataColumn();
            column.DataType = Type.GetType("System.String");
            column.ColumnName = "item2";
            table.Columns.Add(column);

            // Create second column.
            column = new DataColumn();
            column.DataType = Type.GetType("System.String");
            column.ColumnName = "item3";
            table.Columns.Add(column);

            // Create new DataRow objects and add to DataTable.    
            for (int i = 0; i < 10; i++)
            {
                row = table.NewRow();
                row["id"] = i;
                row["item1"] = "item1 " + i;
                row["item2"] = "item2 " + i;
                row["item3"] = "item3 " + i;
                table.Rows.Add(row);
            }
            // Set to DataGrid.DataSource property to the table.
            return table;
        }


        //This code is made by Open XML SDK 2.0 Productivity Tool
        //http://msdn.microsoft.com/en-us/library/bb456488.aspx
        #region Open XML SDK 2.0 for MS

        class OpenXml : IDisposable
        {
            public OpenXml()
            {
                this.SpreadsheetDocument = null;
                this.WorkbookPart = null;
                this.WorksheetPart = null;
                this.Worksheet = null;
                this.SheetData = null;
                this.SharedStringTablePart = null;
            }

            #region Properties

            public SpreadsheetDocument SpreadsheetDocument
            {
                get;
                private set;
            }

            public WorkbookPart WorkbookPart
            {
                get;
                private set;
            }

            public WorksheetPart WorksheetPart
            {
                get;
                private set;
            }

            public Worksheet Worksheet
            {
                get;
                private set;

            }

            public SheetData SheetData
            {
                get;
                private set;
            }

            public SharedStringTablePart SharedStringTablePart
            {
                get;
                private set;
            }

            #endregion

            #region Private Methods

            private void GenerateExtendedFilePropertiesPartContent(ExtendedFilePropertiesPart extendedFilePropertiesPart)
            {
                Ap.Properties properties1 = new Ap.Properties();
                properties1.AddNamespaceDeclaration("vt", "http://schemas.openxmlformats.org/officeDocument/2006/docPropsVTypes");
                Ap.Application application1 = new Ap.Application();
                application1.Text = "Microsoft Excel";
                Ap.DocumentSecurity documentSecurity1 = new Ap.DocumentSecurity();
                documentSecurity1.Text = "0";
                Ap.ScaleCrop scaleCrop1 = new Ap.ScaleCrop();
                scaleCrop1.Text = "false";

                Ap.HeadingPairs headingPairs1 = new Ap.HeadingPairs();

                Vt.VTVector vTVector1 = new Vt.VTVector() { BaseType = Vt.VectorBaseValues.Variant, Size = (UInt32Value)2U };

                Vt.Variant variant1 = new Vt.Variant();
                Vt.VTLPSTR vTLPSTR1 = new Vt.VTLPSTR();
                vTLPSTR1.Text = "WorkSheet";

                variant1.Append(vTLPSTR1);

                Vt.Variant variant2 = new Vt.Variant();
                Vt.VTInt32 vTInt321 = new Vt.VTInt32();
                vTInt321.Text = "1";

                variant2.Append(vTInt321);

                vTVector1.Append(variant1);
                vTVector1.Append(variant2);

                headingPairs1.Append(vTVector1);

                Ap.TitlesOfParts titlesOfParts1 = new Ap.TitlesOfParts();

                Vt.VTVector vTVector2 = new Vt.VTVector() { BaseType = Vt.VectorBaseValues.Lpstr, Size = (UInt32Value)1U };
                Vt.VTLPSTR vTLPSTR2 = new Vt.VTLPSTR();
                vTLPSTR2.Text = "Sheet1";

                vTVector2.Append(vTLPSTR2);

                titlesOfParts1.Append(vTVector2);
                Ap.Company company1 = new Ap.Company();
                company1.Text = "";
                Ap.LinksUpToDate linksUpToDate1 = new Ap.LinksUpToDate();
                linksUpToDate1.Text = "false";
                Ap.SharedDocument sharedDocument1 = new Ap.SharedDocument();
                sharedDocument1.Text = "false";
                Ap.HyperlinksChanged hyperlinksChanged1 = new Ap.HyperlinksChanged();
                hyperlinksChanged1.Text = "false";
                Ap.ApplicationVersion applicationVersion1 = new Ap.ApplicationVersion();
                applicationVersion1.Text = "12.0000";

                properties1.Append(application1);
                properties1.Append(documentSecurity1);
                properties1.Append(scaleCrop1);
                properties1.Append(headingPairs1);
                properties1.Append(titlesOfParts1);
                properties1.Append(company1);
                properties1.Append(linksUpToDate1);
                properties1.Append(sharedDocument1);
                properties1.Append(hyperlinksChanged1);
                properties1.Append(applicationVersion1);

                extendedFilePropertiesPart.Properties = properties1;
            }

            private void GenerateCoreFilePropertiesPartContent(CoreFilePropertiesPart part)
            {
                System.Xml.XmlTextWriter writer = new System.Xml.XmlTextWriter(part.GetStream(System.IO.FileMode.Create), System.Text.Encoding.UTF8);
                writer.WriteRaw("<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>\r\n<cp:coreProperties xmlns:cp=\"http://schemas.openxmlformats.org/package/2006/metadata/core-properties\" xmlns:dc=\"http://purl.org/dc/elements/1.1/\" xmlns:dcterms=\"http://purl.org/dc/terms/\" xmlns:dcmitype=\"http://purl.org/dc/dcmitype/\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"><dc:creator>ihson</dc:creator><cp:lastModifiedBy>ihson</cp:lastModifiedBy><dcterms:created xsi:type=\"dcterms:W3CDTF\">2010-06-08T01:25:13Z</dcterms:created><dcterms:modified xsi:type=\"dcterms:W3CDTF\">2010-06-08T01:25:25Z</dcterms:modified></cp:coreProperties>");
                writer.Flush();
                writer.Close();
            }

            private void GenerateWorkbookPartContent(WorkbookPart workbookPart)
            {
                Workbook workbook1 = new Workbook();
                workbook1.AddNamespaceDeclaration("r", "http://schemas.openxmlformats.org/officeDocument/2006/relationships");
                FileVersion fileVersion1 = new FileVersion() { ApplicationName = "xl", LastEdited = "4", LowestEdited = "4", BuildVersion = "4505" };
                WorkbookProperties workbookProperties1 = new WorkbookProperties() { FilterPrivacy = true, DefaultThemeVersion = (UInt32Value)124226U };

                BookViews bookViews1 = new BookViews();
                WorkbookView workbookView1 = new WorkbookView() { XWindow = 0, YWindow = 60, WindowWidth = (UInt32Value)19200U, WindowHeight = (UInt32Value)11865U };

                bookViews1.Append(workbookView1);

                Sheets sheets1 = new Sheets();
                Sheet sheet1 = new Sheet() { Name = "Sheet1", SheetId = (UInt32Value)1U, Id = "rId1" };

                sheets1.Append(sheet1);
                CalculationProperties calculationProperties1 = new CalculationProperties() { CalculationId = (UInt32Value)124519U };

                workbook1.Append(fileVersion1);
                workbook1.Append(workbookProperties1);
                workbook1.Append(bookViews1);
                workbook1.Append(sheets1);
                workbook1.Append(calculationProperties1);

                workbookPart.Workbook = workbook1;
            }

            private void GenerateWorksheetPartContent(WorksheetPart worksheetPart)
            {
                this.Worksheet = new Worksheet();
                this.Worksheet.AddNamespaceDeclaration("r", "http://schemas.openxmlformats.org/officeDocument/2006/relationships");
                SheetDimension sheetDimension1 = new SheetDimension() { Reference = "A1" };

                SheetViews sheetViews1 = new SheetViews();
                SheetView sheetView1 = new SheetView() { TabSelected = true, WorkbookViewId = (UInt32Value)0U };

                sheetViews1.Append(sheetView1);
                SheetFormatProperties sheetFormatProperties1 = new SheetFormatProperties() { DefaultRowHeight = 15D };
                this.SheetData = new SheetData();
                //PhoneticProperties phoneticProperties1 = new PhoneticProperties() { FontId = (UInt32Value)1U, Type = PhoneticValues.NoConversion };
                PageMargins pageMargins1 = new PageMargins() { Left = 0.7D, Right = 0.7D, Top = 0.75D, Bottom = 0.75D, Header = 0.3D, Footer = 0.3D };
                PageSetup pageSetup1 = new PageSetup() { PaperSize = (UInt32Value)9U, Orientation = OrientationValues.Portrait, HorizontalDpi = (UInt32Value)200U, VerticalDpi = (UInt32Value)200U, Id = "rId1" };

                this.Worksheet.Append(sheetDimension1);
                this.Worksheet.Append(sheetViews1);
                this.Worksheet.Append(sheetFormatProperties1);
                this.Worksheet.Append(this.SheetData);
                //_worksheet.Append(phoneticProperties1);
                this.Worksheet.Append(pageMargins1);
                this.Worksheet.Append(pageSetup1);

                worksheetPart.Worksheet = this.Worksheet;
            }

            private void GenerateWorkbookStylesPartContent(WorkbookStylesPart workbookStylesPart)
            {
                Stylesheet stylesheet1 = new Stylesheet();

                Fonts fonts1 = new Fonts() { Count = (UInt32Value)1U };

                Font font1 = new Font();
                FontSize fontSize1 = new FontSize() { Val = 9D };
                Color color1 = new Color() { Theme = (UInt32Value)1U };
                FontName fontName1 = new FontName() { Val = "Arial" };
                FontFamilyNumbering fontFamilyNumbering1 = new FontFamilyNumbering() { Val = 2 };
                FontCharSet fontCharSet1 = new FontCharSet() { Val = 129 };

                font1.Append(fontSize1);
                font1.Append(color1);
                font1.Append(fontName1);
                font1.Append(fontFamilyNumbering1);
                font1.Append(fontCharSet1);

                fonts1.Append(font1);

                Fills fills1 = new Fills() { Count = (UInt32Value)2U };

                Fill fill1 = new Fill();
                PatternFill patternFill1 = new PatternFill() { PatternType = PatternValues.None };

                fill1.Append(patternFill1);

                Fill fill2 = new Fill();
                PatternFill patternFill2 = new PatternFill() { PatternType = PatternValues.Gray125 };

                fill2.Append(patternFill2);

                fills1.Append(fill1);
                fills1.Append(fill2);

                Borders borders1 = new Borders() { Count = (UInt32Value)1U };

                Border border1 = new Border();
                LeftBorder leftBorder1 = new LeftBorder();
                RightBorder rightBorder1 = new RightBorder();
                TopBorder topBorder1 = new TopBorder();
                BottomBorder bottomBorder1 = new BottomBorder();
                DiagonalBorder diagonalBorder1 = new DiagonalBorder();

                border1.Append(leftBorder1);
                border1.Append(rightBorder1);
                border1.Append(topBorder1);
                border1.Append(bottomBorder1);
                border1.Append(diagonalBorder1);

                borders1.Append(border1);

                CellStyleFormats cellStyleFormats1 = new CellStyleFormats() { Count = (UInt32Value)1U };
                CellFormat cellFormat1 = new CellFormat() { NumberFormatId = (UInt32Value)0U, FontId = (UInt32Value)0U, FillId = (UInt32Value)0U, BorderId = (UInt32Value)0U };

                cellStyleFormats1.Append(cellFormat1);

                CellFormats cellFormats1 = new CellFormats() { Count = (UInt32Value)1U };
                CellFormat cellFormat2 = new CellFormat() { NumberFormatId = (UInt32Value)0U, FontId = (UInt32Value)0U, FillId = (UInt32Value)0U, BorderId = (UInt32Value)0U, FormatId = (UInt32Value)0U };

                cellFormats1.Append(cellFormat2);

                CellStyles cellStyles1 = new CellStyles() { Count = (UInt32Value)1U };
                CellStyle cellStyle1 = new CellStyle() { Name = "", FormatId = (UInt32Value)0U, BuiltinId = (UInt32Value)0U };

                cellStyles1.Append(cellStyle1);
                DifferentialFormats differentialFormats1 = new DifferentialFormats() { Count = (UInt32Value)0U };
                TableStyles tableStyles1 = new TableStyles() { Count = (UInt32Value)0U, DefaultTableStyle = "TableStyleMedium9", DefaultPivotStyle = "PivotStyleLight16" };

                stylesheet1.Append(fonts1);
                stylesheet1.Append(fills1);
                stylesheet1.Append(borders1);
                stylesheet1.Append(cellStyleFormats1);
                stylesheet1.Append(cellFormats1);
                stylesheet1.Append(cellStyles1);
                stylesheet1.Append(differentialFormats1);
                stylesheet1.Append(tableStyles1);

                workbookStylesPart.Stylesheet = stylesheet1;

            }

            private void GenerateThemePartContent(ThemePart themePart)
            {
                A.Theme theme1 = new A.Theme() { Name = "" };
                theme1.AddNamespaceDeclaration("a", "http://schemas.openxmlformats.org/drawingml/2006/main");

                A.ThemeElements themeElements1 = new A.ThemeElements();

                A.ColorScheme colorScheme1 = new A.ColorScheme() { Name = "Office" };

                A.Dark1Color dark1Color1 = new A.Dark1Color();
                A.SystemColor systemColor1 = new A.SystemColor() { Val = A.SystemColorValues.WindowText, LastColor = "000000" };

                dark1Color1.Append(systemColor1);

                A.Light1Color light1Color1 = new A.Light1Color();
                A.SystemColor systemColor2 = new A.SystemColor() { Val = A.SystemColorValues.Window, LastColor = "FFFFFF" };

                light1Color1.Append(systemColor2);

                A.Dark2Color dark2Color1 = new A.Dark2Color();
                A.RgbColorModelHex rgbColorModelHex1 = new A.RgbColorModelHex() { Val = "1F497D" };

                dark2Color1.Append(rgbColorModelHex1);

                A.Light2Color light2Color1 = new A.Light2Color();
                A.RgbColorModelHex rgbColorModelHex2 = new A.RgbColorModelHex() { Val = "EEECE1" };

                light2Color1.Append(rgbColorModelHex2);

                A.Accent1Color accent1Color1 = new A.Accent1Color();
                A.RgbColorModelHex rgbColorModelHex3 = new A.RgbColorModelHex() { Val = "4F81BD" };

                accent1Color1.Append(rgbColorModelHex3);

                A.Accent2Color accent2Color1 = new A.Accent2Color();
                A.RgbColorModelHex rgbColorModelHex4 = new A.RgbColorModelHex() { Val = "C0504D" };

                accent2Color1.Append(rgbColorModelHex4);

                A.Accent3Color accent3Color1 = new A.Accent3Color();
                A.RgbColorModelHex rgbColorModelHex5 = new A.RgbColorModelHex() { Val = "9BBB59" };

                accent3Color1.Append(rgbColorModelHex5);

                A.Accent4Color accent4Color1 = new A.Accent4Color();
                A.RgbColorModelHex rgbColorModelHex6 = new A.RgbColorModelHex() { Val = "8064A2" };

                accent4Color1.Append(rgbColorModelHex6);

                A.Accent5Color accent5Color1 = new A.Accent5Color();
                A.RgbColorModelHex rgbColorModelHex7 = new A.RgbColorModelHex() { Val = "4BACC6" };

                accent5Color1.Append(rgbColorModelHex7);

                A.Accent6Color accent6Color1 = new A.Accent6Color();
                A.RgbColorModelHex rgbColorModelHex8 = new A.RgbColorModelHex() { Val = "F79646" };

                accent6Color1.Append(rgbColorModelHex8);

                A.Hyperlink hyperlink1 = new A.Hyperlink();
                A.RgbColorModelHex rgbColorModelHex9 = new A.RgbColorModelHex() { Val = "0000FF" };

                hyperlink1.Append(rgbColorModelHex9);

                A.FollowedHyperlinkColor followedHyperlinkColor1 = new A.FollowedHyperlinkColor();
                A.RgbColorModelHex rgbColorModelHex10 = new A.RgbColorModelHex() { Val = "800080" };

                followedHyperlinkColor1.Append(rgbColorModelHex10);

                colorScheme1.Append(dark1Color1);
                colorScheme1.Append(light1Color1);
                colorScheme1.Append(dark2Color1);
                colorScheme1.Append(light2Color1);
                colorScheme1.Append(accent1Color1);
                colorScheme1.Append(accent2Color1);
                colorScheme1.Append(accent3Color1);
                colorScheme1.Append(accent4Color1);
                colorScheme1.Append(accent5Color1);
                colorScheme1.Append(accent6Color1);
                colorScheme1.Append(hyperlink1);
                colorScheme1.Append(followedHyperlinkColor1);

                A.FontScheme fontScheme3 = new A.FontScheme() { Name = "Office" };

                A.MajorFont majorFont1 = new A.MajorFont();
                A.LatinFont latinFont1 = new A.LatinFont() { Typeface = "Cambria" };
                A.EastAsianFont eastAsianFont1 = new A.EastAsianFont() { Typeface = "" };
                A.ComplexScriptFont complexScriptFont1 = new A.ComplexScriptFont() { Typeface = "" };
                //A.SupplementalFont supplementalFont1 = new A.SupplementalFont() { Script = "Jpan", Typeface = "ＭＳ Ｐゴシック" };
                //A.SupplementalFont supplementalFont2 = new A.SupplementalFont() { Script = "Hang", Typeface = "맑은 고딕" };
                //A.SupplementalFont supplementalFont3 = new A.SupplementalFont() { Script = "Hans", Typeface = "宋体" };
                //A.SupplementalFont supplementalFont4 = new A.SupplementalFont() { Script = "Hant", Typeface = "新細明體" };
                A.SupplementalFont supplementalFont5 = new A.SupplementalFont() { Script = "Arab", Typeface = "Times New Roman" };
                A.SupplementalFont supplementalFont6 = new A.SupplementalFont() { Script = "Hebr", Typeface = "Times New Roman" };
                A.SupplementalFont supplementalFont7 = new A.SupplementalFont() { Script = "Thai", Typeface = "Tahoma" };
                A.SupplementalFont supplementalFont8 = new A.SupplementalFont() { Script = "Ethi", Typeface = "Nyala" };
                A.SupplementalFont supplementalFont9 = new A.SupplementalFont() { Script = "Beng", Typeface = "Vrinda" };
                A.SupplementalFont supplementalFont10 = new A.SupplementalFont() { Script = "Gujr", Typeface = "Shruti" };
                A.SupplementalFont supplementalFont11 = new A.SupplementalFont() { Script = "Khmr", Typeface = "MoolBoran" };
                A.SupplementalFont supplementalFont12 = new A.SupplementalFont() { Script = "Knda", Typeface = "Tunga" };
                A.SupplementalFont supplementalFont13 = new A.SupplementalFont() { Script = "Guru", Typeface = "Raavi" };
                A.SupplementalFont supplementalFont14 = new A.SupplementalFont() { Script = "Cans", Typeface = "Euphemia" };
                A.SupplementalFont supplementalFont15 = new A.SupplementalFont() { Script = "Cher", Typeface = "Plantagenet Cherokee" };
                A.SupplementalFont supplementalFont16 = new A.SupplementalFont() { Script = "Yiii", Typeface = "Microsoft Yi Baiti" };
                A.SupplementalFont supplementalFont17 = new A.SupplementalFont() { Script = "Tibt", Typeface = "Microsoft Himalaya" };
                A.SupplementalFont supplementalFont18 = new A.SupplementalFont() { Script = "Thaa", Typeface = "MV Boli" };
                A.SupplementalFont supplementalFont19 = new A.SupplementalFont() { Script = "Deva", Typeface = "Mangal" };
                A.SupplementalFont supplementalFont20 = new A.SupplementalFont() { Script = "Telu", Typeface = "Gautami" };
                A.SupplementalFont supplementalFont21 = new A.SupplementalFont() { Script = "Taml", Typeface = "Latha" };
                A.SupplementalFont supplementalFont22 = new A.SupplementalFont() { Script = "Syrc", Typeface = "Estrangelo Edessa" };
                A.SupplementalFont supplementalFont23 = new A.SupplementalFont() { Script = "Orya", Typeface = "Kalinga" };
                A.SupplementalFont supplementalFont24 = new A.SupplementalFont() { Script = "Mlym", Typeface = "Kartika" };
                A.SupplementalFont supplementalFont25 = new A.SupplementalFont() { Script = "Laoo", Typeface = "DokChampa" };
                A.SupplementalFont supplementalFont26 = new A.SupplementalFont() { Script = "Sinh", Typeface = "Iskoola Pota" };
                A.SupplementalFont supplementalFont27 = new A.SupplementalFont() { Script = "Mong", Typeface = "Mongolian Baiti" };
                A.SupplementalFont supplementalFont28 = new A.SupplementalFont() { Script = "Viet", Typeface = "Times New Roman" };
                A.SupplementalFont supplementalFont29 = new A.SupplementalFont() { Script = "Uigh", Typeface = "Microsoft Uighur" };

                majorFont1.Append(latinFont1);
                majorFont1.Append(eastAsianFont1);
                majorFont1.Append(complexScriptFont1);
                //majorFont1.Append(supplementalFont1);
                //majorFont1.Append(supplementalFont2);
                //majorFont1.Append(supplementalFont3);
                //majorFont1.Append(supplementalFont4);
                majorFont1.Append(supplementalFont5);
                majorFont1.Append(supplementalFont6);
                majorFont1.Append(supplementalFont7);
                majorFont1.Append(supplementalFont8);
                majorFont1.Append(supplementalFont9);
                majorFont1.Append(supplementalFont10);
                majorFont1.Append(supplementalFont11);
                majorFont1.Append(supplementalFont12);
                majorFont1.Append(supplementalFont13);
                majorFont1.Append(supplementalFont14);
                majorFont1.Append(supplementalFont15);
                majorFont1.Append(supplementalFont16);
                majorFont1.Append(supplementalFont17);
                majorFont1.Append(supplementalFont18);
                majorFont1.Append(supplementalFont19);
                majorFont1.Append(supplementalFont20);
                majorFont1.Append(supplementalFont21);
                majorFont1.Append(supplementalFont22);
                majorFont1.Append(supplementalFont23);
                majorFont1.Append(supplementalFont24);
                majorFont1.Append(supplementalFont25);
                majorFont1.Append(supplementalFont26);
                majorFont1.Append(supplementalFont27);
                majorFont1.Append(supplementalFont28);
                majorFont1.Append(supplementalFont29);

                A.MinorFont minorFont1 = new A.MinorFont();
                A.LatinFont latinFont2 = new A.LatinFont() { Typeface = "Arial" };
                A.EastAsianFont eastAsianFont2 = new A.EastAsianFont() { Typeface = "" };
                A.ComplexScriptFont complexScriptFont2 = new A.ComplexScriptFont() { Typeface = "" };
                //A.SupplementalFont supplementalFont30 = new A.SupplementalFont() { Script = "Jpan", Typeface = "ＭＳ Ｐゴシック" };
                //A.SupplementalFont supplementalFont31 = new A.SupplementalFont() { Script = "Hang", Typeface = "맑은 고딕" };
                //A.SupplementalFont supplementalFont32 = new A.SupplementalFont() { Script = "Hans", Typeface = "宋体" };
                //A.SupplementalFont supplementalFont33 = new A.SupplementalFont() { Script = "Hant", Typeface = "新細明體" };
                A.SupplementalFont supplementalFont34 = new A.SupplementalFont() { Script = "Arab", Typeface = "Arial" };
                A.SupplementalFont supplementalFont35 = new A.SupplementalFont() { Script = "Hebr", Typeface = "Arial" };
                A.SupplementalFont supplementalFont36 = new A.SupplementalFont() { Script = "Thai", Typeface = "Tahoma" };
                A.SupplementalFont supplementalFont37 = new A.SupplementalFont() { Script = "Ethi", Typeface = "Nyala" };
                A.SupplementalFont supplementalFont38 = new A.SupplementalFont() { Script = "Beng", Typeface = "Vrinda" };
                A.SupplementalFont supplementalFont39 = new A.SupplementalFont() { Script = "Gujr", Typeface = "Shruti" };
                A.SupplementalFont supplementalFont40 = new A.SupplementalFont() { Script = "Khmr", Typeface = "DaunPenh" };
                A.SupplementalFont supplementalFont41 = new A.SupplementalFont() { Script = "Knda", Typeface = "Tunga" };
                A.SupplementalFont supplementalFont42 = new A.SupplementalFont() { Script = "Guru", Typeface = "Raavi" };
                A.SupplementalFont supplementalFont43 = new A.SupplementalFont() { Script = "Cans", Typeface = "Euphemia" };
                A.SupplementalFont supplementalFont44 = new A.SupplementalFont() { Script = "Cher", Typeface = "Plantagenet Cherokee" };
                A.SupplementalFont supplementalFont45 = new A.SupplementalFont() { Script = "Yiii", Typeface = "Microsoft Yi Baiti" };
                A.SupplementalFont supplementalFont46 = new A.SupplementalFont() { Script = "Tibt", Typeface = "Microsoft Himalaya" };
                A.SupplementalFont supplementalFont47 = new A.SupplementalFont() { Script = "Thaa", Typeface = "MV Boli" };
                A.SupplementalFont supplementalFont48 = new A.SupplementalFont() { Script = "Deva", Typeface = "Mangal" };
                A.SupplementalFont supplementalFont49 = new A.SupplementalFont() { Script = "Telu", Typeface = "Gautami" };
                A.SupplementalFont supplementalFont50 = new A.SupplementalFont() { Script = "Taml", Typeface = "Latha" };
                A.SupplementalFont supplementalFont51 = new A.SupplementalFont() { Script = "Syrc", Typeface = "Estrangelo Edessa" };
                A.SupplementalFont supplementalFont52 = new A.SupplementalFont() { Script = "Orya", Typeface = "Kalinga" };
                A.SupplementalFont supplementalFont53 = new A.SupplementalFont() { Script = "Mlym", Typeface = "Kartika" };
                A.SupplementalFont supplementalFont54 = new A.SupplementalFont() { Script = "Laoo", Typeface = "DokChampa" };
                A.SupplementalFont supplementalFont55 = new A.SupplementalFont() { Script = "Sinh", Typeface = "Iskoola Pota" };
                A.SupplementalFont supplementalFont56 = new A.SupplementalFont() { Script = "Mong", Typeface = "Mongolian Baiti" };
                A.SupplementalFont supplementalFont57 = new A.SupplementalFont() { Script = "Viet", Typeface = "Arial" };
                A.SupplementalFont supplementalFont58 = new A.SupplementalFont() { Script = "Uigh", Typeface = "Microsoft Uighur" };

                minorFont1.Append(latinFont2);
                minorFont1.Append(eastAsianFont2);
                minorFont1.Append(complexScriptFont2);
                //minorFont1.Append(supplementalFont30);
                //minorFont1.Append(supplementalFont31);
                //minorFont1.Append(supplementalFont32);
                //minorFont1.Append(supplementalFont33);
                minorFont1.Append(supplementalFont34);
                minorFont1.Append(supplementalFont35);
                minorFont1.Append(supplementalFont36);
                minorFont1.Append(supplementalFont37);
                minorFont1.Append(supplementalFont38);
                minorFont1.Append(supplementalFont39);
                minorFont1.Append(supplementalFont40);
                minorFont1.Append(supplementalFont41);
                minorFont1.Append(supplementalFont42);
                minorFont1.Append(supplementalFont43);
                minorFont1.Append(supplementalFont44);
                minorFont1.Append(supplementalFont45);
                minorFont1.Append(supplementalFont46);
                minorFont1.Append(supplementalFont47);
                minorFont1.Append(supplementalFont48);
                minorFont1.Append(supplementalFont49);
                minorFont1.Append(supplementalFont50);
                minorFont1.Append(supplementalFont51);
                minorFont1.Append(supplementalFont52);
                minorFont1.Append(supplementalFont53);
                minorFont1.Append(supplementalFont54);
                minorFont1.Append(supplementalFont55);
                minorFont1.Append(supplementalFont56);
                minorFont1.Append(supplementalFont57);
                minorFont1.Append(supplementalFont58);

                fontScheme3.Append(majorFont1);
                fontScheme3.Append(minorFont1);

                A.FormatScheme formatScheme1 = new A.FormatScheme() { Name = "Office" };

                A.FillStyleList fillStyleList1 = new A.FillStyleList();

                A.SolidFill solidFill1 = new A.SolidFill();
                A.SchemeColor schemeColor1 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };

                solidFill1.Append(schemeColor1);

                A.GradientFill gradientFill1 = new A.GradientFill() { RotateWithShape = true };

                A.GradientStopList gradientStopList1 = new A.GradientStopList();

                A.GradientStop gradientStop1 = new A.GradientStop() { Position = 0 };

                A.SchemeColor schemeColor2 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };
                A.Tint tint1 = new A.Tint() { Val = 50000 };
                A.SaturationModulation saturationModulation1 = new A.SaturationModulation() { Val = 300000 };

                schemeColor2.Append(tint1);
                schemeColor2.Append(saturationModulation1);

                gradientStop1.Append(schemeColor2);

                A.GradientStop gradientStop2 = new A.GradientStop() { Position = 35000 };

                A.SchemeColor schemeColor3 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };
                A.Tint tint2 = new A.Tint() { Val = 37000 };
                A.SaturationModulation saturationModulation2 = new A.SaturationModulation() { Val = 300000 };

                schemeColor3.Append(tint2);
                schemeColor3.Append(saturationModulation2);

                gradientStop2.Append(schemeColor3);

                A.GradientStop gradientStop3 = new A.GradientStop() { Position = 100000 };

                A.SchemeColor schemeColor4 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };
                A.Tint tint3 = new A.Tint() { Val = 15000 };
                A.SaturationModulation saturationModulation3 = new A.SaturationModulation() { Val = 350000 };

                schemeColor4.Append(tint3);
                schemeColor4.Append(saturationModulation3);

                gradientStop3.Append(schemeColor4);

                gradientStopList1.Append(gradientStop1);
                gradientStopList1.Append(gradientStop2);
                gradientStopList1.Append(gradientStop3);
                A.LinearGradientFill linearGradientFill1 = new A.LinearGradientFill() { Angle = 16200000, Scaled = true };

                gradientFill1.Append(gradientStopList1);
                gradientFill1.Append(linearGradientFill1);

                A.GradientFill gradientFill2 = new A.GradientFill() { RotateWithShape = true };

                A.GradientStopList gradientStopList2 = new A.GradientStopList();

                A.GradientStop gradientStop4 = new A.GradientStop() { Position = 0 };

                A.SchemeColor schemeColor5 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };
                A.Shade shade1 = new A.Shade() { Val = 51000 };
                A.SaturationModulation saturationModulation4 = new A.SaturationModulation() { Val = 130000 };

                schemeColor5.Append(shade1);
                schemeColor5.Append(saturationModulation4);

                gradientStop4.Append(schemeColor5);

                A.GradientStop gradientStop5 = new A.GradientStop() { Position = 80000 };

                A.SchemeColor schemeColor6 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };
                A.Shade shade2 = new A.Shade() { Val = 93000 };
                A.SaturationModulation saturationModulation5 = new A.SaturationModulation() { Val = 130000 };

                schemeColor6.Append(shade2);
                schemeColor6.Append(saturationModulation5);

                gradientStop5.Append(schemeColor6);

                A.GradientStop gradientStop6 = new A.GradientStop() { Position = 100000 };

                A.SchemeColor schemeColor7 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };
                A.Shade shade3 = new A.Shade() { Val = 94000 };
                A.SaturationModulation saturationModulation6 = new A.SaturationModulation() { Val = 135000 };

                schemeColor7.Append(shade3);
                schemeColor7.Append(saturationModulation6);

                gradientStop6.Append(schemeColor7);

                gradientStopList2.Append(gradientStop4);
                gradientStopList2.Append(gradientStop5);
                gradientStopList2.Append(gradientStop6);
                A.LinearGradientFill linearGradientFill2 = new A.LinearGradientFill() { Angle = 16200000, Scaled = false };

                gradientFill2.Append(gradientStopList2);
                gradientFill2.Append(linearGradientFill2);

                fillStyleList1.Append(solidFill1);
                fillStyleList1.Append(gradientFill1);
                fillStyleList1.Append(gradientFill2);

                A.LineStyleList lineStyleList1 = new A.LineStyleList();

                A.Outline outline1 = new A.Outline() { Width = 9525, CapType = A.LineCapValues.Flat, CompoundLineType = A.CompoundLineValues.Single, Alignment = A.PenAlignmentValues.Center };

                A.SolidFill solidFill2 = new A.SolidFill();

                A.SchemeColor schemeColor8 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };
                A.Shade shade4 = new A.Shade() { Val = 95000 };
                A.SaturationModulation saturationModulation7 = new A.SaturationModulation() { Val = 105000 };

                schemeColor8.Append(shade4);
                schemeColor8.Append(saturationModulation7);

                solidFill2.Append(schemeColor8);
                A.PresetDash presetDash1 = new A.PresetDash() { Val = A.PresetLineDashValues.Solid };

                outline1.Append(solidFill2);
                outline1.Append(presetDash1);

                A.Outline outline2 = new A.Outline() { Width = 25400, CapType = A.LineCapValues.Flat, CompoundLineType = A.CompoundLineValues.Single, Alignment = A.PenAlignmentValues.Center };

                A.SolidFill solidFill3 = new A.SolidFill();
                A.SchemeColor schemeColor9 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };

                solidFill3.Append(schemeColor9);
                A.PresetDash presetDash2 = new A.PresetDash() { Val = A.PresetLineDashValues.Solid };

                outline2.Append(solidFill3);
                outline2.Append(presetDash2);

                A.Outline outline3 = new A.Outline() { Width = 38100, CapType = A.LineCapValues.Flat, CompoundLineType = A.CompoundLineValues.Single, Alignment = A.PenAlignmentValues.Center };

                A.SolidFill solidFill4 = new A.SolidFill();
                A.SchemeColor schemeColor10 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };

                solidFill4.Append(schemeColor10);
                A.PresetDash presetDash3 = new A.PresetDash() { Val = A.PresetLineDashValues.Solid };

                outline3.Append(solidFill4);
                outline3.Append(presetDash3);

                lineStyleList1.Append(outline1);
                lineStyleList1.Append(outline2);
                lineStyleList1.Append(outline3);

                A.EffectStyleList effectStyleList1 = new A.EffectStyleList();

                A.EffectStyle effectStyle1 = new A.EffectStyle();

                A.EffectList effectList1 = new A.EffectList();

                A.OuterShadow outerShadow1 = new A.OuterShadow() { BlurRadius = 40000L, Distance = 20000L, Direction = 5400000, RotateWithShape = false };

                A.RgbColorModelHex rgbColorModelHex11 = new A.RgbColorModelHex() { Val = "000000" };
                A.Alpha alpha1 = new A.Alpha() { Val = 38000 };

                rgbColorModelHex11.Append(alpha1);

                outerShadow1.Append(rgbColorModelHex11);

                effectList1.Append(outerShadow1);

                effectStyle1.Append(effectList1);

                A.EffectStyle effectStyle2 = new A.EffectStyle();

                A.EffectList effectList2 = new A.EffectList();

                A.OuterShadow outerShadow2 = new A.OuterShadow() { BlurRadius = 40000L, Distance = 23000L, Direction = 5400000, RotateWithShape = false };

                A.RgbColorModelHex rgbColorModelHex12 = new A.RgbColorModelHex() { Val = "000000" };
                A.Alpha alpha2 = new A.Alpha() { Val = 35000 };

                rgbColorModelHex12.Append(alpha2);

                outerShadow2.Append(rgbColorModelHex12);

                effectList2.Append(outerShadow2);

                effectStyle2.Append(effectList2);

                A.EffectStyle effectStyle3 = new A.EffectStyle();

                A.EffectList effectList3 = new A.EffectList();

                A.OuterShadow outerShadow3 = new A.OuterShadow() { BlurRadius = 40000L, Distance = 23000L, Direction = 5400000, RotateWithShape = false };

                A.RgbColorModelHex rgbColorModelHex13 = new A.RgbColorModelHex() { Val = "000000" };
                A.Alpha alpha3 = new A.Alpha() { Val = 35000 };

                rgbColorModelHex13.Append(alpha3);

                outerShadow3.Append(rgbColorModelHex13);

                effectList3.Append(outerShadow3);

                A.Scene3DType scene3DType1 = new A.Scene3DType();

                A.Camera camera1 = new A.Camera() { Preset = A.PresetCameraValues.OrthographicFront };
                A.Rotation rotation1 = new A.Rotation() { Latitude = 0, Longitude = 0, Revolution = 0 };

                camera1.Append(rotation1);

                A.LightRig lightRig1 = new A.LightRig() { Rig = A.LightRigValues.ThreePoints, Direction = A.LightRigDirectionValues.Top };
                A.Rotation rotation2 = new A.Rotation() { Latitude = 0, Longitude = 0, Revolution = 1200000 };

                lightRig1.Append(rotation2);

                scene3DType1.Append(camera1);
                scene3DType1.Append(lightRig1);

                A.Shape3DType shape3DType1 = new A.Shape3DType();
                A.BevelTop bevelTop1 = new A.BevelTop() { Width = 63500L, Height = 25400L };

                shape3DType1.Append(bevelTop1);

                effectStyle3.Append(effectList3);
                effectStyle3.Append(scene3DType1);
                effectStyle3.Append(shape3DType1);

                effectStyleList1.Append(effectStyle1);
                effectStyleList1.Append(effectStyle2);
                effectStyleList1.Append(effectStyle3);

                A.BackgroundFillStyleList backgroundFillStyleList1 = new A.BackgroundFillStyleList();

                A.SolidFill solidFill5 = new A.SolidFill();
                A.SchemeColor schemeColor11 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };

                solidFill5.Append(schemeColor11);

                A.GradientFill gradientFill3 = new A.GradientFill() { RotateWithShape = true };

                A.GradientStopList gradientStopList3 = new A.GradientStopList();

                A.GradientStop gradientStop7 = new A.GradientStop() { Position = 0 };

                A.SchemeColor schemeColor12 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };
                A.Tint tint4 = new A.Tint() { Val = 40000 };
                A.SaturationModulation saturationModulation8 = new A.SaturationModulation() { Val = 350000 };

                schemeColor12.Append(tint4);
                schemeColor12.Append(saturationModulation8);

                gradientStop7.Append(schemeColor12);

                A.GradientStop gradientStop8 = new A.GradientStop() { Position = 40000 };

                A.SchemeColor schemeColor13 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };
                A.Tint tint5 = new A.Tint() { Val = 45000 };
                A.Shade shade5 = new A.Shade() { Val = 99000 };
                A.SaturationModulation saturationModulation9 = new A.SaturationModulation() { Val = 350000 };

                schemeColor13.Append(tint5);
                schemeColor13.Append(shade5);
                schemeColor13.Append(saturationModulation9);

                gradientStop8.Append(schemeColor13);

                A.GradientStop gradientStop9 = new A.GradientStop() { Position = 100000 };

                A.SchemeColor schemeColor14 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };
                A.Shade shade6 = new A.Shade() { Val = 20000 };
                A.SaturationModulation saturationModulation10 = new A.SaturationModulation() { Val = 255000 };

                schemeColor14.Append(shade6);
                schemeColor14.Append(saturationModulation10);

                gradientStop9.Append(schemeColor14);

                gradientStopList3.Append(gradientStop7);
                gradientStopList3.Append(gradientStop8);
                gradientStopList3.Append(gradientStop9);

                A.PathGradientFill pathGradientFill1 = new A.PathGradientFill() { Path = A.PathShadeValues.Circle };
                A.FillToRectangle fillToRectangle1 = new A.FillToRectangle() { Left = 50000, Top = -80000, Right = 50000, Bottom = 180000 };

                pathGradientFill1.Append(fillToRectangle1);

                gradientFill3.Append(gradientStopList3);
                gradientFill3.Append(pathGradientFill1);

                A.GradientFill gradientFill4 = new A.GradientFill() { RotateWithShape = true };

                A.GradientStopList gradientStopList4 = new A.GradientStopList();

                A.GradientStop gradientStop10 = new A.GradientStop() { Position = 0 };

                A.SchemeColor schemeColor15 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };
                A.Tint tint6 = new A.Tint() { Val = 80000 };
                A.SaturationModulation saturationModulation11 = new A.SaturationModulation() { Val = 300000 };

                schemeColor15.Append(tint6);
                schemeColor15.Append(saturationModulation11);

                gradientStop10.Append(schemeColor15);

                A.GradientStop gradientStop11 = new A.GradientStop() { Position = 100000 };

                A.SchemeColor schemeColor16 = new A.SchemeColor() { Val = A.SchemeColorValues.PhColor };
                A.Shade shade7 = new A.Shade() { Val = 30000 };
                A.SaturationModulation saturationModulation12 = new A.SaturationModulation() { Val = 200000 };

                schemeColor16.Append(shade7);
                schemeColor16.Append(saturationModulation12);

                gradientStop11.Append(schemeColor16);

                gradientStopList4.Append(gradientStop10);
                gradientStopList4.Append(gradientStop11);

                A.PathGradientFill pathGradientFill2 = new A.PathGradientFill() { Path = A.PathShadeValues.Circle };
                A.FillToRectangle fillToRectangle2 = new A.FillToRectangle() { Left = 50000, Top = 50000, Right = 50000, Bottom = 50000 };

                pathGradientFill2.Append(fillToRectangle2);

                gradientFill4.Append(gradientStopList4);
                gradientFill4.Append(pathGradientFill2);

                backgroundFillStyleList1.Append(solidFill5);
                backgroundFillStyleList1.Append(gradientFill3);
                backgroundFillStyleList1.Append(gradientFill4);

                formatScheme1.Append(fillStyleList1);
                formatScheme1.Append(lineStyleList1);
                formatScheme1.Append(effectStyleList1);
                formatScheme1.Append(backgroundFillStyleList1);

                themeElements1.Append(colorScheme1);
                themeElements1.Append(fontScheme3);
                themeElements1.Append(formatScheme1);
                A.ObjectDefaults objectDefaults1 = new A.ObjectDefaults();
                A.ExtraColorSchemeList extraColorSchemeList1 = new A.ExtraColorSchemeList();

                theme1.Append(themeElements1);
                theme1.Append(objectDefaults1);
                theme1.Append(extraColorSchemeList1);

                themePart.Theme = theme1;
            }

            private void GenerateDrawingsPartContent(DrawingsPart drawingsPart, int positionX, int positionY, long extentX, long extentY, string sheetID)
            {
                Xdr.WorksheetDrawing worksheetDrawing1 = new Xdr.WorksheetDrawing();
                worksheetDrawing1.AddNamespaceDeclaration("xdr", "http://schemas.openxmlformats.org/drawingml/2006/spreadsheetDrawing");
                worksheetDrawing1.AddNamespaceDeclaration("a", "http://schemas.openxmlformats.org/drawingml/2006/main");

                Xdr.OneCellAnchor oneCellAnchor1 = new Xdr.OneCellAnchor() { };

                Xdr.FromMarker fromMarker1 = new Xdr.FromMarker();
                Xdr.ColumnId columnId1 = new Xdr.ColumnId();
                columnId1.Text = positionX.ToString();
                Xdr.ColumnOffset columnOffset1 = new Xdr.ColumnOffset();
                columnOffset1.Text = "0";
                Xdr.RowId rowId1 = new Xdr.RowId();
                rowId1.Text = positionY.ToString();
                Xdr.RowOffset rowOffset1 = new Xdr.RowOffset();
                rowOffset1.Text = "0";

                fromMarker1.Append(columnId1);
                fromMarker1.Append(columnOffset1);
                fromMarker1.Append(rowId1);
                fromMarker1.Append(rowOffset1);

                Xdr.Extent extent1 = new Xdr.Extent() { Cx = extentX, Cy = extentY };

                Xdr.Picture picture1 = new Xdr.Picture();

                Xdr.NonVisualPictureProperties nonVisualPictureProperties1 = new Xdr.NonVisualPictureProperties();
                Xdr.NonVisualDrawingProperties nonVisualDrawingProperties1 = new Xdr.NonVisualDrawingProperties() { Id = (UInt32Value)1025U, Name = "Picture" };

                Xdr.NonVisualPictureDrawingProperties nonVisualPictureDrawingProperties1 = new Xdr.NonVisualPictureDrawingProperties();
                A.PictureLocks pictureLocks1 = new A.PictureLocks() { NoChangeAspect = true, NoChangeArrowheads = true };

                nonVisualPictureDrawingProperties1.Append(pictureLocks1);

                nonVisualPictureProperties1.Append(nonVisualDrawingProperties1);
                nonVisualPictureProperties1.Append(nonVisualPictureDrawingProperties1);

                Xdr.BlipFill blipFill1 = new Xdr.BlipFill();

                A.Blip blip1 = new A.Blip() { Embed = sheetID };
                blip1.AddNamespaceDeclaration("r", "http://schemas.openxmlformats.org/officeDocument/2006/relationships");
                A.SourceRectangle sourceRectangle1 = new A.SourceRectangle();

                A.Stretch stretch1 = new A.Stretch();
                A.FillRectangle fillRectangle1 = new A.FillRectangle();

                stretch1.Append(fillRectangle1);

                blipFill1.Append(blip1);
                blipFill1.Append(sourceRectangle1);
                blipFill1.Append(stretch1);

                Xdr.ShapeProperties shapeProperties1 = new Xdr.ShapeProperties() { BlackWhiteMode = A.BlackWhiteModeValues.Auto };

                A.Transform2D transform2D1 = new A.Transform2D();
                A.Offset offset1 = new A.Offset() { X = 0L, Y = 0L };
                //A.Offset offset1 = new A.Offset() { X = 0L, Y = 5L };
                //A.Extents extents1 = new A.Extents() { Cx = 3733800L, Cy = 5600700L };
                A.Extents extents1 = new A.Extents() { Cx = extentX, Cy = extentY };

                transform2D1.Append(offset1);
                transform2D1.Append(extents1);

                A.PresetGeometry presetGeometry1 = new A.PresetGeometry() { Preset = A.ShapeTypeValues.Rectangle };
                A.AdjustValueList adjustValueList1 = new A.AdjustValueList();

                presetGeometry1.Append(adjustValueList1);
                A.NoFill noFill1 = new A.NoFill();

                A.Outline outline1 = new A.Outline() { Width = 1 };
                A.NoFill noFill2 = new A.NoFill();
                A.Miter miter1 = new A.Miter() { Limit = 800000 };
                A.HeadEnd headEnd1 = new A.HeadEnd();
                A.TailEnd tailEnd1 = new A.TailEnd() { Type = A.LineEndValues.None, Width = A.LineEndWidthValues.Medium, Length = A.LineEndLengthValues.Medium };

                outline1.Append(noFill2);
                outline1.Append(miter1);
                outline1.Append(headEnd1);
                outline1.Append(tailEnd1);
                A.EffectList effectList1 = new A.EffectList();

                shapeProperties1.Append(transform2D1);
                shapeProperties1.Append(presetGeometry1);
                shapeProperties1.Append(noFill1);
                shapeProperties1.Append(outline1);
                shapeProperties1.Append(effectList1);

                picture1.Append(nonVisualPictureProperties1);
                picture1.Append(blipFill1);
                picture1.Append(shapeProperties1);
                Xdr.ClientData clientData1 = new Xdr.ClientData();


                oneCellAnchor1.Append(fromMarker1);
                oneCellAnchor1.Append(extent1);
                oneCellAnchor1.Append(picture1);
                oneCellAnchor1.Append(clientData1);

                worksheetDrawing1.Append(oneCellAnchor1);

                drawingsPart.WorksheetDrawing = worksheetDrawing1;
            }

            #endregion

            #region Public Methods

            public void CreateSpreadsheetWorkbook(string filePath)
            {
                SpreadsheetDocument = SpreadsheetDocument.Create(filePath, SpreadsheetDocumentType.Workbook);

                ExtendedFilePropertiesPart extendedFilePropertiesPart = this.SpreadsheetDocument.AddNewPart<ExtendedFilePropertiesPart>();
                GenerateExtendedFilePropertiesPartContent(extendedFilePropertiesPart);

                CoreFilePropertiesPart coreFilePropertiesPart = this.SpreadsheetDocument.AddNewPart<CoreFilePropertiesPart>();
                GenerateCoreFilePropertiesPartContent(coreFilePropertiesPart);

                this.WorkbookPart = this.SpreadsheetDocument.AddWorkbookPart();
                GenerateWorkbookPartContent(this.WorkbookPart);

                this.WorksheetPart = this.WorkbookPart.AddNewPart<WorksheetPart>("rId1");
                GenerateWorksheetPartContent(this.WorksheetPart);

                WorkbookStylesPart workbookStylesPart = this.WorkbookPart.AddNewPart<WorkbookStylesPart>(this.SpreadsheetDocument.GetIdOfPart(extendedFilePropertiesPart));
                GenerateWorkbookStylesPartContent(workbookStylesPart);

                ThemePart themePart = this.WorkbookPart.AddNewPart<ThemePart>();
                GenerateThemePartContent(themePart);
            }

            #endregion

            public void Dispose()
            {
                this.SheetData = null;
                this.Worksheet = null;
                this.WorksheetPart = null;
                this.WorkbookPart = null;
                this.SharedStringTablePart = null;

                if (this.SpreadsheetDocument != null)
                {
                    this.SpreadsheetDocument.Close();
                    this.SpreadsheetDocument = null;
                }
            }
        }

        #endregion
    }
}
